Listing 1 -- A comprehensive example of a standard lookup/edit routine

    // Assumes these variables are private

    lastname  := space(10)
    firstname := space(10
    addr1     := space(30)
    addr2     := space(30)
    addr3     := space(30)
    tel       := space(10)
    balance   := 00000.00

    @ ... GET lastname VALID lookup(lastname)
    @ ... GET firstname
    @ ... GET addr1
    @ ... GET addr2
    @ ... GET addr3
    @ ... GET tel  PICTURE "...."
    @ ... GET balance

    READ


    FUNCTION lookup(lastname)

      // SEEK in database here ....
      firstname := "Rick..."
      addr1     := "10126 Wisner  ...."  
      addr2     := "Mission Hills ...."
      tel       := "8188923398"
      balance   :=  -1000

      // If balance is -ve, change its color
      IF balance < 0
        getlist[7]:colorspec := "R/B,B/R"  
      ENDIF

      // Redraw all gets
      aeval(getlist, {|go| go:display() })

    RETURN .T.

