Listing 4 -- Sample code for a password protection scheme

; ---------------------------------------------------------------------------
; passlevel() returns the level number of a given password
; ---------------------------------------------------------------------------
Proc passlevel(pass)
    Private procname,pass,rv,x
    procname = "passlevel"
    pass="^"+pass+"|"
    For x From 6 To 1 Step -1
        rv = ( Search(pass,passwlist[x]) <> 0 )
     If rv Then
         Return x-1
     Endif
    EndFor
    Return -1
EndProc

;------------------------------------------------------------------------
;   pass() gets a password and verifies it, return True or False
;------------------------------------------------------------------------

Proc pass(level)
    Private procname,level,rv,passw1
    procname="pass"
    rv=False
    @ 0,0
    ?? "Enter password: "
    passw=GetPassword(8,"*")
    passw1="^"+passw+"|"
    rv = ( Search(passw1,passwlist[level+1]) <> 0 )
    If Not rv Then
        dispmess("Invalid password!","",True)
    EndIf
    @ 0,0 Clear EOL
    Return rv
EndProc

;------------------------------------------------------------------------
;   loadpass() loads the passwords from the password file
;------------------------------------------------------------------------

Proc loadpass()
    Private procname
    procname="loadpass"
    ;---------------------------------------------------------
    ; psf.db contains the passwords in the following fields
    ; these fields can contain the passwords in a list, i.e,
    ; level 0 can contain three passwords entered like this:
    ; ^password1|^password2|^password3|
    ; the ^ and | chars are delimeters for the passwords
    ;---------------------------------------------------------
    PassWord "zzzzz"
    View "psf"
    passwlist[1]=[level 0]
    passwlist[2]=[level 1]
    passwlist[3]=[level 2]
    passwlist[4]=[level 3]
    passwlist[5]=[level 4]
    passwlist[6]=[level 5]
    ClearAll
    UnPassword "zzzzz"
EndProc

