Listing 1 -- These code fragments show how to work with dbPublisher from
within PAL

     Batch file which sets environment variables

rem DBSET.BAT sets environment variables needed by dbPublisher
echo off
cls
set dbpub=q:
set texfonts=q:\dbpub\font\metrics\
set texfmts=q:\dbpub\control\
set texinputs=;.\;q:\dbpub\styles\
set texoutputs=;
set texswap=.\
set tmp=.\
set sgmlpath=q:\dbpub\control\
set dviexe=q:\dbpub\programs\dvi2hp.exe
set dviargs= /dev:Lpt1 /co:1 /st:1 /nu:9999 /norev

     PAL code which runs dbPublisher
;------------------------------------------------------------------------
; poprint1() prints a finished PO in final form using dbPublisher
;------------------------------------------------------------------------
Proc poprint1()
    Private potype,procname
    procname = "poprint1"

    ; this file can't be privtable'd since dbPublisher needs to
    ; know exactly where it is, thus we must lock it

    Lock "poprint2" fl

    If (RetVal=False) Then
        dispmess(ErrorMessage(),"",True)
        Return
    EndIf

    While (True)
        ShowMenu
            "Detail" : "Print PO with detail amounts showing",
            "No Detail" : "Print PO without detail amounts showing",
            "Quit" : "Return to previous menu"
            Until -35 Keyto vh
            Default "Detail"
        To potype

        If (potype="Esc" Or potype="Quit") Then
            ClearAll
            Return
        EndIf

        If (vh=-35) Then
            vhelpm()
        Else
            QuitLoop
        EndIf

    EndWhile
    Empty "poprint"

    dispmess("Running queries and adding records...","Please wait.",False)
    poquery1()
    poquery2()
    Add "answer" "poprint"
    poquery3()
    poquery4()
    Rename "Answer" "poprint2"
    poquery5()
    dispmess("Printing PO...","",False)
    If (potype="Detail") Then
        Run Big "POPRINT2"
    Else
        Run Big "POPRINT3"
    EndIf
    UnLock "poprint2"fl

EndProc

     Batch file which runs dbPublisher

echo off
cls
rem dbp is dbPublishers runtime executable
dbp POPRINT2.RT

